﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Text;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Graphics.Imaging;
using Windows.UI.Core;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace BarcodeReader
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }
        string barcodeResult;
        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            //Load the image from the embbeded resource.
            Stream imgStream = typeof(MainPage).GetTypeInfo().Assembly.GetManifestResourceStream("BarcodeReader.Assets.Barcode.png");
                 
            //Set the image stream position.     
            imgStream.Position = 0;

            //Get the image RGB data.
            var BitmapImageDecoder = await BitmapDecoder.CreateAsync(imgStream.AsRandomAccessStream());

            PixelDataProvider provider = await BitmapImageDecoder.GetPixelDataAsync().AsTask().ConfigureAwait(false);
            var imageData = provider.DetachPixelData();

            //initialize the ZXing barcode reader
            ZXing.BarcodeReader reader = new ZXing.BarcodeReader();

            //Reader the barcode
            ZXing.Result[] results = reader.DecodeMultiple(imageData, (int)BitmapImageDecoder.PixelWidth, (int)BitmapImageDecoder.PixelHeight, ZXing.RGBLuminanceSource.BitmapFormat.Unknown);

            StringBuilder builder = new StringBuilder();

            foreach (ZXing.Result result in results)
            {
                builder.Append("Barcode Type : " + result.BarcodeFormat.ToString() + "\nBarcode Text:" + result.Text + "\n\n");
            }

            await this.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () =>
            {                
                textBox.Text = builder.ToString();
            });                

        }      
    }
}
